import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Frame;
import java.awt.TextField;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import quadbase.ChartAPI.QbChart;
import quadbase.util.PickData;

public class CallBack extends Applet {

	static final long serialVersionUID = 1;

	static TextField textField;

	public static void main(String[] args) {
		try {
			CallBack chart = new CallBack();
			Frame frame = new Frame();
			frame.setLayout(new BorderLayout());
			frame.add("Center", chart.doCallBack(null));
			frame.add("South", textField = new TextField(50));
			frame.addWindowListener(new WindowAdapter() {
				@Override
				public void windowClosing(WindowEvent e) {
					System.exit(0);
				}
			});
			frame.setSize(800, 600);
			frame.setVisible(true);

		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}

	@Override
	public void init() {
		setLayout(new BorderLayout());
		add("Center", doCallBack(this));
		add("South", textField = new TextField(50));
	}

	Component doCallBack(Applet parent) {
		// Do not use EspressManager
		QbChart.setEspressManagerUsed(false);

		// Open the template
		QbChart chart = new QbChart(parent, // container 
				"CallBack.cht"); // template

		chart.addActionListener(new callBackActionListener());

		// Show chart in Viewer
		return chart;

	}

	class callBackActionListener implements ActionListener {

		static final long serialVersionUID = 1;

		public void actionPerformed(ActionEvent e) {
			Object arg = ((QbChart) e.getSource()).getArgument();

			String click;

			switch (e.getModifiers()) {
			case QbChart.LEFT_SINGLECLICK:
				click = "Left single click";
				break;
			case QbChart.LEFT_DOUBLECLICK:
				click = "Left double click";
				break;
			case QbChart.RIGHT_SINGLECLICK:
				click = "Right single click";
				break;
			case QbChart.RIGHT_DOUBLECLICK:
				click = "Right double click";
				break;
			default: // shall not happen
				click = "Error !";
			}

			if (arg instanceof PickData) {
				textField.setText(((PickData) arg).toString() + " " + click);
			} else {
				textField.setText((String) arg + " " + click);
			}
		}
	}
}
